# API v1 REST

Cette API v1 REST est **dépréciée** : ⚠️ 
- cette API v1 REST sera supprimée à moyen terme 
- la documentation _"officielle"_ ne contient plus cette API v1 REST
- issue [#5298 - Déprécier l'API v1](https://github.com/betagouv/demarches-simplifiees.fr/issues/5298)

Cette API v1 REST  du logiciel _Démarches-Simplifiées_  :
- ne permet pas les modifications sur les démarches et  dossiers
- permet de consulter :
  - les informations d'une démarche,
  - la liste des dossiers d'une démarche,
  - les détails d'un dossier spécifique.


## Exemple d'utilisation avec CURL et JQ

### Pré-requis
- `curl`
- `jq`

```bash
sudo apt-get install curl
sudo apt-get install jq
```

### Variables

- Le **jeton d’identification** de l’API (token) est à récupérer sur la **page de profil** d'un compte utilisateur avec le rôle "administration". 
- L'URL du profil est : `https://example.com/profil`

```bash
API_REST_URL="https://example.com/api/v1/" 
API_JETON="<YOUR_TOKEN>"
PROCEDURE_ID=2
DOSSIER_ID=1
```

### Informations concernant une démarche

```bash
# Requête à l'API REST de DS
curl "${API_REST_URL}procedures/${PROCEDURE_ID}?token=${API_JETON}" | jq
```

#### Résultat
```json
{
  "procedure": {
    "label": "Inscription à la Bibliothèque",
    "id": 2,
    "description": "S'inscrire à la bibliothèque de la ville ... ",
    "organisation": null,
    "direction": null,
    "archived_at": null,
    "geographic_information": {
      "use_api_carto": false,
      "quartiers_prioritaires": false,
      "cadastre": false
    },
    "total_dossier": 4,
    "link": "https://example.com/commencer/ville-new-york_inscription-a-la-bibliotheque",
    "state": "publiee",
    "types_de_champ": [
      (...)
      {
        "id": 2,
        "libelle": "Adresse",
        "type_champ": "address",
        "order_place": 1,
        "description": null
      }
    ],
    "types_de_champ_private": [],
    "types_de_piece_justificative": [],
    "service": {
      "id": 1,
      "email": "example@example.com",
      "name": "Service Culture",
      "type_organization": "collectivite_territoriale",
      "organization": "Mairie de New York",
      "phone": "04 67 00 00 00",
      "schedule": "Du lundi au vendredi de 9 h 30 à 17 h 30. ",
      "address": "20 rue de la république \r\nXXXX New York"
    }
  }
}
```

### Liste de tous les dossiers d'une démarche (avec l'état)

```bash
# Requête à l'API REST de DS
curl "${API_REST_URL}procedures/${PROCEDURE_ID}/dossiers/?token=${API_JETON}" | jq
```

#### Résultat
```json
{
  "dossiers": [
    {
      "id": 1,
      "updated_at": "2020-07-19T20:59:29.684Z",
      "initiated_at": "2020-07-08T23:13:38.023Z",
      "state": "received"
    },
    {
      "id": 2,
      "updated_at": "2020-07-19T20:04:17.628Z",
      "initiated_at": "2020-07-19T19:57:21.529Z",
      "state": "initiated"
    },
    {
      "id": 3,
      "updated_at": "2020-07-19T21:47:51.227Z",
      "initiated_at": "2020-07-19T21:00:58.317Z",
      "state": "received"
    },
    {
      "id": 4,
      "updated_at": "2020-07-19T21:16:51.428Z",
      "initiated_at": "2020-07-19T21:01:59.963Z",
      "state": "closed"
    }
  ],
  "pagination": {
    "page": 1,
    "resultats_par_page": 100,
    "nombre_de_page": 1
  }
}
```

### Informations sur un dossier d'une démarche

```bash
# Requête à l'API REST de DS
curl "${API_REST_URL}procedures/${PROCEDURE_ID}/dossiers/${DOSSIER_ID}?token=${API_JETON}" | jq
```

#### Résultat
```json
{
  "dossier": {
    "id": 1,
    "created_at": "2020-07-08T23:12:57.722Z",
    "updated_at": "2020-07-19T20:59:29.684Z",
    "archived": false,
    "email": "utilisateur@example.com",
    "state": "received",
    "simplified_state": "En instruction",
    "initiated_at": "2020-07-08T23:13:38.023Z",
    "received_at": "2020-07-19T20:55:46.494Z",
    "processed_at": null,
    "motivation": null,
    "instructeurs": [
      "instructeur@example.com"
    ],
    "individual": {
      "civilite": "Mme",
      "nom": "L'éponge",
      "prenom": "Bob"
    },
    "entreprise": null,
    "etablissement": null,
    "cerfa": [],
    "commentaires": [
      {
        "email": "contactexample.com",
        "body": "[Votre dossier nº 1 a bien été déposé (Inscription à la Bibliothèque)]<br><br><!--XRAY START 2 /opt/ds/app/views/notification_mailer/default_templates/initiated_mail.html.haml-->\n<p>\nBonjour,\n</p>\n<p>\nVotre dossier nº 1\n<strong>a bien été déposé</strong>.\nSi besoin est, vous pouvez encore y apporter des modifications.\n</p>\n<!--XRAY START 1 /opt/ds/app/views/notification_mailer/default_templates/_signature.html.haml-->\n<p>\nBonne journée,\n<br>\n Service Culture\n</p>\n\n<!--XRAY END 1-->\n\n<!--XRAY END 2-->",
        "created_at": "2020-07-08T23:41:27.097Z",
        "attachment": null
      },
      {
        "email": "contactexample.com",
        "body": "[Votre dossier nº 1 va être examiné (Inscription à la Bibliothèque)]<br><br><!--XRAY START 4 /opt/ds/app/views/notification_mailer/default_templates/received_mail.html.haml-->\n<p>\nBonjour,\n</p>\n<p>\nVotre dossier nº 1\na bien été reçu et\n<strong>pris en charge</strong>.\nIl va maintenant être examiné par le service.\n</p>\n<!--XRAY START 3 /opt/ds/app/views/notification_mailer/default_templates/_signature.html.haml-->\n<p>\nBonne journée,\n<br>\n Service Culture\n</p>\n\n<!--XRAY END 3-->\n\n<!--XRAY END 4-->",
        "created_at": "2020-07-19T20:04:18.149Z",
        "attachment": null
      },
    ],
    "champs_private": [],
    "pieces_justificatives": [],
    "types_de_piece_justificative": [],
    "avis": [],
    "champs": [
      {
        "value": "John Doe",
        "type_de_champ": {
          "id": 1,
          "libelle": "Nom",
          "type_champ": "text",
          "order_place": 0,
          "description": null
        }
      },
      {
        "value": "Avenue Lamartine 31100 Toulouse",
        "type_de_champ": {
          "id": 2,
          "libelle": "Adresse",
          "type_champ": "address",
          "order_place": 1,
          "description": null
        }
      }
    ]
  }
}

```

