# Environnements

Plusieurs environnements avec des comportements très différents (envoi de mails, https, ...)
- [environment "development"](development/)
  - [config/environments/development.rb](https://github.com/betagouv/demarches-simplifiees.fr/blob/dev/config/environments/development.rb)
- [environment "production"](production/)
  - [config/environments/production.rb](https://github.com/betagouv/demarches-simplifiees.fr/blob/dev/config/environments/production.rb)


Ressources :
- [Documentation - Rails Environment Settings](https://guides.rubyonrails.org/configuring.html#rails-environment-settings)
- [Documentation - Creating Rails Environments](https://guides.rubyonrails.org/configuring.html#creating-rails-environments)
> By default Rails ships with three environments: "development", "test", and "production". While these are sufficient for most use cases, there are circumstances when you want more environments.
> 
> Imagine you have a server which mirrors the production environment but is only used for testing. Such a server is commonly called a "staging server". To define an environment called "staging" for this server, just create a file called config/environments/staging.rb. Please use the contents of any existing file in config/environments as a starting point and make the necessary changes from there.
> 
> That environment is no different than the default ones, start a server with rails server -e staging, a console with rails console -e staging, Rails.env.staging? works, etc.
