# Last manual steps for installation of Démarches simplifiées 

## 1. Get into the box

Once the vagrant box is build:

```shell script
vagrant ssh
```

## 2. Run install commands

```shell script
cd /home/vagrant/demarches-simplifiees.fr
yarn install 
bundle install
bin/setup
```

## 3. Define IP address and run server

```shell script
ip a    # Lists IP addresses 
/home/vagrant/demarches-simplifiees.fr/bin/rails server --daemon --binding=<IP-of-vagrant-box> 
/home/vagrant/demarches-simplifiees.fr/bin/delayed_job run &
``` 

In case of error of previous commands, run:

```shell script
echo 'export PATH=$PATH:/home/ds/rbenv/shims:/home/ds/rbenv/bin' >> /home/ds/.bashrc
```

And relaunch terminal so that changes be taken into account, then re-type last two commands.

## 4. Use Démarches-Simplifiées

### As anonymous user

In your browser, type in: `http://<IP-of-vagrant-box>:3000/` 

### As registered user

1. Go to `http://<IP-of-vagrant-box>:3000/users/sign_in`
2. Log in with login: `test@exemple.fr` and password: `this is a very complicated password !`
3. Check user's emails at `http://<IP-of-vagrant-box>:3000/letter_opener`
4. Validate registration 

### As a superadmin

1. Go to `http://<IP-of-vagrant-box>:3000/manager/sign_in`
2. Log in with your Github credentials (the ones associated to the "Oauth App" token)
