# Vagrant box for _Démarches-Simplifiées_

Vagrant box for Démarches Simplifiées (DS)

see: [vagrant-demarches-simplifiees](https://gitlab.adullact.net/demarches-simplifiees/vagrant-demarches-simplifiees) repository

## Prerequisites

* Virtualbox 
* Vagrant
* Git
* a Ruby version management tool like RVM or [RBenv](https://github.com/rbenv/rbenv)
* r10k (`gem install r10k`)

## Usage

### 1. Grab source code of Démarches Simplifiées

```shell script
mkdir my-project # "my-project" is the parent directory holding DS source code
cd my-project   
git clone git@github.com:betagouv/demarches-simplifiees.fr.git
```

Note: you may clone your own fork of the source code (if you want to contribute for instance)

### 2. Grab source code of vagrant-demarches-simplifiees 

```shell script
git clone git@gitlab.adullact.net:demarches-simplifiees/vagrant-demarches-simplifiees.git
```

### 3. Prepare the vagrant box

```shell script
cd vagrant-demarches-simplifiees
./BUILD.sh
```

### 4. Run the vagrant box

```shell script
vagrant up
```

### 5. Finish manual configuration

Complete the instructions from [Configuration_last_manual_steps](Configuration_last_manual_steps.md).

### How to rebuild the vagrant box 

```shell script
vagrant destroy -f && vagrant up
```
